﻿
namespace IGShowcase.AirplaneSeatingChart.Models
{
	/// <summary>
	/// Represents a seat class in the plane data with information about the seats and customer satisfaction.
	/// </summary>
	public class SeatClass
	{
		#region Public Properties
		/// <summary>
        /// Gets or sets the category.
		/// </summary>
        /// <value>The category.</value>
        public string SeatCategory { get; set; }
		/// <summary>
		/// Gets or sets the description.
		/// </summary>
		/// <value>The description.</value>
		public string Description { get; set; }
		/// <summary>
		/// Gets or sets the seat count.
		/// </summary>
		/// <value>The seat count.</value>
		public int SeatCount { get; set; }
		/// <summary>
		/// Gets or sets the seat pitch.
		/// </summary>
		/// <value>The seat pitch.</value>
		public int SeatPitch { get; set; }
		/// <summary>
		/// Gets or sets the width of the seat.
		/// </summary>
		/// <value>The width of the seat.</value>
		public int SeatWidth { get; set; }

		/// <summary>
		/// The data for the customer satisfaction chart.
		/// </summary>
		public CustomerSatisfactionDataCollection CustomerSatisfaction { get; set; }
		#endregion Public Properties
	}
}
